## Example 1.2 Simulated bivariate Gaussian

##load code
source("CovMcdF.r")
## Load data
y<-read.table('ybivariate.txt')


#### Otherwise generate your own data
library(mvtnorm)
n<-20
S=matrix(c(1,0.5,0.5,1),2,2)
y<-rmvnorm(n,sigma=S)

library(ellipse)
### drawing classical tolerance ellipse
plot(y, xlab='',ylab='', xlim=c(-3,3),ylim=c(-3,3))
q.mle<-((n-1)^2)*qbeta(.90,p/2,(n-p-1)/2)/n
lines(ellipse(x=cov(y),center=colMeans(y),level=0.9, t= sqrt(q.mle)),lty=2)

## robust fit based on the reweighted MCD
## load the code from reweighted MCD
library(rrcov)
y.mcd<-CovMcdF(y, alpha=0.75)

### or by using library rrcov

library(rrcov)
y.mcd<-CovMcd(y, alpha=0.75)
w<-sum(y.mcd$wt)
q.mcd<-((w-1)^2)*qbeta(.90,p/2,(w-p-1)/2)/w
lines(ellipse(x=y.mcd$cov,center=y.mcd$center,level=0.9, t= sqrt(q.mcd)),lty=1)