library(foreign)

# read data
demo=read.dbf("demographic.dbf")

# scatterplots of birth vs death rate 
plot(demo$Birthrate[-c(5,6,23)],demo$Deathrate[-c(5,6,23)],xlim=c(6,13),xlab="Birthrate",ylab="Deathrate")
identify(demo$Birthrate[-c(5,6,23)],demo$Deathrate[-c(5,6,23)],labels=demo[-c(5,6,23),1])

# identification of contamination 

plot(demo$Birthrate[-c(5,6,23)],demo$Deathrate[-c(5,6,23)],xlim=c(6,13),xlab="Birthrate",ylab="Deathrate",cex=1.5)
 text(demo[-c(5,6,23),][c(7,15,20),]$Birthrate-0.2,demo[-c(5,6,23),][c(7,15,20),]$Deathrate-0.2,demo[-c(5,6,23),][c(7,15,20),1],cex=1.5)

rownames(demo)=demo[,1]
km=kmeans(demo[-c(5,6,23),7:8],2)
pm=pam(demo[-c(5,6,23),7:8],2)

library(tclust)
dat=demo[-c(5,6,23),]

tk=tkmeans(demo[-c(5,6,23),7:8],2)
tc=tclust(demo[-c(5,6,23),7:8],2)

library(snipEM)
V=as.matrix(demo[-c(5,6,23),7:8])
V[1:20,]=1
V[sample(40,4)]=0
R=tc$clu
R[R==0]=2
sk=skmeans(as.matrix(demo[-c(5,6,23),7:8]),2,V,R)

dat[sk$V[,1]==0,1]
dat[sk$V[,2]==0,1]

sn=sclust(as.matrix(demo[-c(5,6,23),7:8]),2,sk$V,sk$clu)

## cluster labels ##
 
data.frame(dat[,1],km$clust,pm$cluster,tk$clu,tc$clust,sk$clust,sn$R)

## cluster centroids ##

tapply(dat[,7],km$clust,mean)
tapply(dat[,7],pm$cluster,mean)
tapply(dat[,7],tk$clu,mean)
tapply(dat[,7],tc$clust,mean)
tapply(dat[,7],sk$clust,mean)
tapply(dat[,7],sn$R,mean)

tapply(dat[,8],km$clust,mean)
tapply(dat[,8],pm$cluster,mean)
tapply(dat[,8],tk$clu,mean)
tapply(dat[,8],tc$clust,mean)
tapply(dat[,8],sk$clust,mean)
tapply(dat[,8],sn$R,mean)

