## Example 1.1 Simulated univariate Gaussian

y<-c(28.69,  23.81,  27.27, 26.49,  26.95,  22.24,
29.86, 24.59, 27.25, 
26.16, 22.76, 25.60, 23.75, 16.54, 23.58, 24.66, 25.43, 24.14,
22.74, 31.08, 26.06, 22.66, 29.91, 15.34, 28.85, 23.88, 24.03, 
31.93, 22.15, 27.95)

mean(y);sd(y)
median(y);mad(y)

### Exact confidence interval
low.t<-mean(y)-qt(.975,29)*sd(y)/sqrt(30)
upp.t<-mean(y)+qt(.975,29)*sd(y)/sqrt(30)
round(c(low.t,upp.t),2)

### Asymptotic confidence interval
low.z<-mean(y)-qnorm(.975)*sd(y)/sqrt(30)
upp.z<-mean(y)+qnorm(.975)*sd(y)/sqrt(30)
round(c(low.z,upp.z),2)

### Asymptotic confidence interval based on median and MAD
low.mm.z<-median(y)-qnorm(.975)*mad(y)*sqrt(pi/2)/sqrt(30)
upp.mm.z<-median(y)+qnorm(.975)*mad(y)*sqrt(pi/2)/sqrt(30)
round(c(low.mm.z,upp.mm.z),2)

## contaminated sample
yc<-y; yc[which.max(yc)]<-61.93
mean(yc);sd(yc)
median(yc);mad(yc)

### Exact confidence interval
low.t<-mean(yc)-qt(.975,29)*sd(yc)/sqrt(30)
upp.t<-mean(yc)+qt(.975,29)*sd(yc)/sqrt(30)
round(c(low.t,upp.t),2)

### Asymptotic confidence interval
low.z<-mean(yc)-qnorm(.975)*sd(yc)/sqrt(30)
upp.z<-mean(yc)+qnorm(.975)*sd(yc)/sqrt(30)
round(c(low.z,upp.z),2)

### Asymptotic confidence interval based on median and MAD
low.mm.z<-median(yc)-qnorm(.975)*mad(yc)*sqrt(pi/2)/sqrt(30)
upp.mm.z<-median(yc)+qnorm(.975)*mad(yc)*sqrt(pi/2)/sqrt(30)
round(c(low.mm.z,upp.mm.z),2)


