snipdkm=function(X,k1,k2,Z,D=0.1,maxiter=100,tol=1e-6,inits=NULL) {

n=nrow(X)
p=ncol(X)

estm=function(X,k1,k2,Z,R1,R2) {

m=matrix(NA,k1,k2) 

for(i in 1:k1) {
for(j in 1:k2) {

m[i,j]=sum(X[R1==i,R2==j]*Z[R1==i,R2==j])/sum(Z[R1==i,R2==j])

}}

m}

if(is.null(inits)) {

R1=sample(k1,n,replace=T)
R2=sample(k2,p,replace=T)

}

if(!is.null(inits)) {
R1=inits$R1
R2=inits$R2}

## compute row profile 

m=estm(X,k1,k2,Z,R1,R2)

obj=0
for(i in 1:k1) {
for(j in 1:k2) {

obj=obj+sum(Z[R1==i,R2==j]*(X[R1==i,R2==j]-m[i,j])^2)

}}

objold=obj*2

while(objold-obj>tol) {

## distances

dr=matrix(0,n,k1) 
dc=matrix(0,p,k2)
for(i in 1:k1) {
for(j in 1:k2) {
if(sum(R2==j)>1) {
dr[,i]=dr[,i]+apply(Z[,R2==j]*(X[,R2==j]-m[i,j])^2,1,sum)}
if(sum(R2==j)==1) {
dr[,i]=dr[,i]+(Z[,R2==j]*(X[,R2==j]-m[i,j])^2)
}
}
}

for(i in 1:k2) {
for(j in 1:k1) {
if(sum(R1==j)>1) {
dc[,i]=dc[,i]+apply(Z[R1==j,]*(X[R1==j,]-m[j,i])^2,2,sum)}
if(sum(R1==j)==1) {
dc[,i]=dc[,i]+Z[R1==j,]*(X[R1==j,]-m[j,i])^2
}
}
}

## memberships 

w1=apply(dr,1,which.min)
w2=apply(dc,1,which.min)

R1=w1*ifelse(apply(Z,1,sum)>0,1,0)
R2=w2*ifelse(apply(Z,2,sum)>0,1,0)

## update Z 

Zc=Z
objnow=0
for(i in 1:k1) {
for(j in 1:k2) {

objnow=objnow+sum(Z[R1==i,R2==j]*(X[R1==i,R2==j]-m[i,j])^2)

}}

objc=objnow
for(t in 1:maxiter) {

Zold=Zc
w1=sample(which(Zc==1),1)
if(sum(Zc==0)>1) {
w0=sample(which(Zc==0),1)
}
if(sum(Zc==0)==1) {
w0=which(Zc==0)
}
Zc[w1]=0
Zc[w0]=1

objcm1=objc
objc=0
for(i in 1:k1) {
for(j in 1:k2) {

objc=objc+sum(Zc[R1==i,R2==j]*(X[R1==i,R2==j]-m[i,j])^2)

}}

pt=exp(-log(t+1)*(objc-objcm1)/D)
if(pt>1) {pt=1}

if(objc<objnow) {
Z=Zc
objnow=objc
}

if(rbinom(1,1,pt)==0) {
Zc=Zold
}

}

## new centroid

m=estm(X,k1,k2,Z,R1,R2)

## new loss 

objold=obj
obj=0
for(i in 1:k1) {
for(j in 1:k2) {

obj=obj+sum(Z[R1==i,R2==j]*(X[R1==i,R2==j]-m[i,j])^2)

}}
}

return(list(obj=obj,m=m,R1=R1,R2=R2,Z=Z))}
