
trimdkm=function(X,I,J,o1,o2,initial=1) {

n=nrow(X)
p=ncol(X)

# allocate 
  
d=matrix(0,n,I)
dtmp=array(0,c(n,I,J))
d2=matrix(0,p,J)
dtmp2=array(0,c(p,J,I))
m=matrix(0,I,J)

# functions

Wc=function(rg,j) {
  
U=X[rowp==rg,colp==j]
t(U)%*%U}

Wr=function(rc,j) {
    U=t(X[rowp==i,colp==rc])
    t(U)%*%U}

distR = function(i,rg,j) {
  gin=ginv(Wc(rg,j),tol=.Machine$double.eps)
  mahalanobis(X[i,colp==j],m[rg,j],gin,inverted=TRUE)}

distC = function(j,rc,i) {
  gin = ginv(Wr(rc,j),tol=.Machine$double.eps)
  mahalanobis(t(X[rowp==i,j]),t(m[i,rc]),gin,inverted=TRUE)}

meanx=function(X,rowp,colp,I,J) {
  
for(i in 1:I) {
  for(j in 1:J) {
m[i,j]=mean(X[rowp==i,colp==j])}}

m}

  # no scale

distRn = function(i,rg,j) {
  dat=matrix(X[i,colp==j],nrow=1)
  mahalanobis(dat,m[rg,j],diag(ncol(dat)),inverted=T)}

distCn = function(j,rc,i) {
  dat=matrix(t(X[rowp==i,j]),nrow=1)
  mahalanobis(dat,t(m[i,rc]),diag(ncol(dat)),inverted=T)}

# preparation

if(!is.matrix(X)) {X=as.matrix(X)}
n=nrow(X)
p=ncol(X)
eps=1

# I row groups
# J col groups
# o1 row outliers
# o2 col outliers

# initialize

if(initial == 1) {

# random start is better.

rowp=sample(1:I,n,replace=T)
colp=sample(1:J,p,replace=T)
u=rep(1,n)
if(o1>0) {
u[sample(1:n,o1)]=0
}
v=rep(1,p)
if(o2>0) {
v[sample(1:p,o2)]=0
}
}

if(initial == 2) {

# initialize (pam, as usual)

# random rowp

pa=pam(X,I+1)

rowp=pa$cluster


vm=which(table(rowp)==min(table(rowp)))[1]
u=rep(1,n)
tvm=table(rowp)[vm]
if(tvm>o1) {
  u[rowp==vm][1:o1]=0
 rowp[rowp==vm]=sample((1:(I+1))[-vm],table(rowp)[vm],replace=T)}
if(tvm==o1) {
  u[rowp==vm]=0
  rowp[rowp==vm]=sample((1:(I+1))[-vm],table(rowp)[vm],replace=T)}
if(tvm<o1) {
u[rowp==vm]=0
hh=sample((1:n)[-which(rowp==vm)],o1-sum(rowp==vm))
u[hh]=0
rowp[c(which(rowp==vm),hh)]=sample((1:(I+1))[-vm],o1,replace=T)}

rowp=as.factor(rowp)
levels(rowp)=1:I
rowp=as.numeric(as.vector(rowp))

# colp column memberships (0 -> outlier) 

pa=pam(t(X),J+1)

colp=pa$cluster

v=rep(1,p)

vm=which(table(colp)==min(table(colp)))[1]
tvm=table(colp)[vm]
if(tvm>o2) {
  v[colp==vm][1:o2]=0
 colp[colp==vm]=sample((1:(J+1))[-vm],table(colp)[vm],replace=T)}
if(tvm==o2) {
  v[colp==vm]=0
  colp[colp==vm]=sample((1:(J+1))[-vm],table(colp)[vm],replace=T)}
if(tvm<o2) {
v[colp==vm]=0
hh=sample((1:p)[-which(colp==vm)],o2-sum(colp==vm))
v[hh]=0
colp[c(which(colp==vm),hh)]=sample((1:(J+1))[-vm],o2,replace=T)}

colp=as.factor(colp)
levels(colp)=1:J
colp=as.numeric(as.vector(colp))}

# m 
rowp[u==0]=0
colp[v==0]=0

m=meanx(X,rowp,colp,I,J) 
# engine:

while(eps>0.001) {

# M STEP 

##############
# row updater#
##############

# WRC scaling (mahalanobis)

#for(j in 1:J) {
#for(rg in 1:I) {
#  dtmp[,rg,j]=sapply(1:n,distR,rg=rg,j=j)}
#}

# without scaling (LS!)

tc=table(colp)
  
for(j in 1:J) {
for(rg in 1:I) {
 dtmp[,rg,j]=sapply(1:n,distRn,rg=rg,j=j)}
}

for(i in 1:n) {
d[i,]=apply(dtmp[i,,],1,sum)}

rowpold=rowp
rowp=max.col(-d)


if(o1>0) {
# row outliers

dfinal=apply(d,1,min)

rowp[which(dfinal>sort(dfinal)[n-o1])]=0
}
###############
# col updater #
###############

# with Wc (mahalanobis)

#for(i in 1:I) {
#  for(rc in 1:J) {
#    dtmp2[,rc,i]=sapply(1:p,distC,rc=rc,i=i)}}

# without scaling (LS!)

tr=table(rowp)

for(i in 1:I) {
  for(rc in 1:J) {
    dtmp2[,rc,i]=sapply(1:p,distCn,rc=rc,i=i)}}
      
for(j in 1:p) {
  d2[j,]=apply(dtmp2[j,,],1,sum)}


colpold=colp
colp=max.col(-d2)

if(o2>0) {
# col outliers

dfinal2=apply(d2,1,min)

colp[which(dfinal2>sort(dfinal2)[p-o2])]=0
}
# E STEP

###############
# new means ###
###############

mold=m
m=meanx(X,rowp,colp,I,J) 

## CONVERGENCE??? 

eps=mean((sort(m)-sort(mold))^2)}

obj=0
for(i in 1:I) {
for(j in 1:J) {
obj=obj+sum((X[rowp==i,colp==j]-m[i,j])^2)

}}

list(m=m,rowp=rowp,colp=colp,obj=obj)}
