library(rrcov) 
library(rrcovHD)
library(MASS)
data(iris)

## sample reduction (stratified statistics) 

apply(iris[,-5],2,function(x) tapply(x,iris$Species,mean))
apply(iris[,-5],2,function(x) tapply(x,iris$Species,sd))

covMcd(iris[iris[,5]==levels(iris[,5])[1],-5])
covMcd(iris[iris[,5]==levels(iris[,5])[2],-5])
covMcd(iris[iris[,5]==levels(iris[,5])[3],-5])

## cross-validation ## 

B=1000
n=nrow(iris)
errors=matrix(NA,B,3)
roberrors=errors

f=function(obj,test) {
nrow(test)-sum(diag(table(predict(obj,test[,-5])$class,test[,5])))
}
frob=function(obj,test) {
nrow(test)-sum(diag(table(attributes(unclass(predict(obj,test[,-5])))$class,test[,5])))}



for(i in 1:B) {

w=c(sample(50,40),sample(50,40)+50,sample(50,40)+100)
ld=lda(iris[w,5]~.,data=iris[w,-5])

## robust methods ## 

lpp=Linda(iris[w,5]~.,data=iris[w,-5])
lpi=Linda(iris[w,5]~.,data=iris[w,-5],control="fsa")

## outlier detection in the test set ## 

testi=iris[-w,]
flag=which(getFlag(OutlierMahdist(testi[,-5],testi[,5],control="M"))==1)

## errors ## 

errors[i,]=c(f(ld,testi),frob(lpp,testi),frob(lpi,testi))/nrow(testi)
roberrors[i,]=c(f(ld,testi[flag,]),frob(lpp,testi[flag,]),frob(lpi,testi[flag,]))/length(flag)

}


ta=matrix(0,3,3) 

for(i in 1:B) {

w=c(sample(50,40),sample(50,40)+50,sample(50,40)+100)
ld=lda(iris[w,5]~.,data=iris[w,-5])

testi=iris[-w,]

pr=predict(ld,testi)

ta=table(testi[,5],pr$class)+ta

}

ta/apply(ta,1,sum)

levels(iris[,5])=c("se","ve","vi")
ld=lda(iris[,5]~.,data=iris[,-5])
plot(ld)

