library(rrcov) 
library(rrcovHD)
library(MASS)

sp=read.table("spam20.dat")

n=nrow(sp)
out=c(rep(1,30),rep(0,n-30))

B=1000

f=function(obj,test) {
nrow(test)-sum(diag(table(predict(obj,test[,-21])$class,test[,21])))
}
frob=function(obj,test) {
nrow(test)-sum(diag(table(attributes(unclass(predict(obj,test[,-21])))$class,test[,21])))}

errors=matrix(NA,B,5)
roberrors=matrix(NA,B,5)

for(i in 1:B) {

w=c(sample(30,25),30+sample(n-30,(n-30)*0.7))

ld=lda(out[w]~.,data=sp[w,])
qd=qda(out[w]~.,data=sp[w,])

lpi=Linda(sp[w,],out[w])
lpf=Linda(sp[w,],out[w],control="fsa")
qdr=QdaCov(sp[w,],out[w])

## outlier detection in the test set ## 

testi=sp[-w,]
flag=c(1:5,5+which(getFlag(OutlierMahdist(testi[-c(1:5),]))==1))

## errors ## 

testi=cbind(testi,out[-w])
errors[i,]=c(f(ld,testi),f(qd,testi),frob(lpi,testi),frob(lpf,testi),frob(qdr,testi))/nrow(testi)
roberrors[i,]=c(f(ld,testi[flag,]),f(qd,testi[flag,]),frob(lpi,testi[flag,]),frob(lpf,testi[flag,]),frob(qdr,testi[flag,]))/length(flag)

if(i>2) {
print(apply(errors[1:i,],2,mean))
print(apply(roberrors[1:i,],2,mean))
print(i)
}
}

lp=lda(out~.,data=sp)
qd=qda(out~.,data=sp)

lpi=Linda(sp,out)
lpf=Linda(sp,out,control="fsa")
qdr=QdaCov(sp,out)

ta=matrix(0,2,2) 
ta2=matrix(0,2,2)


for(i in 1:B) {
w=c(sample(30,25),30+sample(n-30,(n-30)*0.7))

ld=lda(out[w]~.,data=sp[w,])

qdr=QdaCov(sp[w,],out[w])

ta=table(out[-w],predict(ld,sp[-w,])$class)+ta
ta2=table(out[-w],attributes(unclass(predict(qdr,sp[-w,])))$class)+ta2

}

ta/apply(ta,1,sum)
ta2/apply(ta2,1,sum)
