libraryt(rrcov)
source('CovMcdF.r')

#### Butterfly data
library(ade4)
data(butterfly)
X<-butterfly$env

### Figure 2.21

### MLE Distance plot
mle.X<-mahalanobis(X,colMeans(X),cov(X))
plot(sqrt(mle.X),ylab='Mahalanobis Distance', xlab='Index',main='MLE',ylim=c(0,5))
ccw=((nrow(X)-1)^2)/nrow(X)
quantmle<-qbeta(.975,ncol(X)/2, (nrow(X)-ncol(X)-1)/2)*ccw
abline(h=quantmle^0.5,lty=1)
identify(sqrt(mle.X),labels=rownames(X))

### RMCD Distance plot
est2<-CovMcdF(X,alpha=0.75)
nw<-sum(est2$wt)
ccw1=((nw-1)^2)/nw
ps<-4;ns<-16
quantrmcd<-qbeta(.975,ps/2, (nw-ps-1)/2)*ccw1
ccw2=(nw^2-1)*ps/nw/(nw-ps)
quantout<-qf(.975,ps, nw-ps)*ccw2


plot(sqrt(est2$mah),ylab='Robust Distance', xlab='Index',main='RMCD',type='n')
abline(h=quantout^0.5)
abline(h=quantrmcd^0.5,lty=2)
inx.bad<-which(est2$wt==0)
inx.good<-which(est2$wt!=0)
points(inx.good,sqrt(est2$mah[inx.good]),pch=1)
points(inx.bad,sqrt(est2$mah[inx.bad]),pch=2)

## MM distance plot (not reported in the example)
est3<-CovMMest(X)
plot(est3, which='distance')

## OGK Distance plot
est4<-CovOgk(X)
plot(est4, which='distance')

### SD Distance plot
est5<-CovSde(X)
plot(est5, which='distance')


### Figure 2.20
par(mfrow=c(2,2))
plotcorr(cor(X),type='upper')
plotcorr(cov2cor(est2$cov),type='upper')
plotcorr(cov2cor(est4@cov),type='upper')
plotcorr(cov2cor(est5@cov),type='upper')

