## S-estimation

### compute the tuning constant by fixing BP
# p is the dimension; c the tuning constant; bp the breakdown

find.tuning<-function(p,bp,c)
{
	c<-c^2
	out<-3*p/c*pchisq(c,p+2)-3/(c^2)*p*(p+2)*pchisq(c,p+4)+
	p*(p+2)*(p+4)/(c^3)*pchisq(c,p+6)+1-pchisq(c,p)
	out-bp
	
	}
	
compute.tuning.bp<-function(p,bp,low=1,upp=15){
	uniroot(find.tuning, p=p,bp=bp,lower=low,upper=upp)$root
	}	



## ARE for the location vector
# p is the dimension; c the tuning constant; eff the efficiency

areTmult<-function(p,c,eff)
{
	c2<-c^2
	num<-(p+2)*(p+4)*pchisq(c2,p+4)/c^4-2*(p+2)*pchisq(c2,p+2)/c2+pchisq(c2,p)
	num<-num^2
	den<-(p+2)*(p+4)*(p+6)*(p+8)*pchisq(c2,p+10)/c^8-4*(p+2)*(p+4)*(p+6)*pchisq(c2,p+8)/c^6+
	6*(p+2)*(p+4)*pchisq(c2,p+6)/c^4-4*(p+2)*pchisq(c2,p+4)/c2+pchisq(c2,p+2)
	out<-num/den
	out-eff
	
	}

### compute tuning constant for given efficiency	
compute.tuning.eff<-function(p,eff,low=1,upp=15){
	uniroot(areTmult, p=p,eff=eff,lower=low,upper=upp)$root
	}

### compute efficiency for given tuning constant			
compute.tuning.eff.c<-function(p,c,low=0,upp=1){
	uniroot(areTmult, p=p,c=c,lower=low,upper=upp)$root
	}		

