library(rrcov)
library(robustbase)
library(MASS)
source('univariate_fun.r')


## Figure 2.1
##left panel
c0.975<-find.c(0.975)
c0.95<-find.c(0.95)
c0.85<-find.c(0.85)
curve(IFhuber(x,c=c0.975),from=-4,to=4,ylab='IF')
curve(IFhuber(x,c=c0.95), add=T,lty=2)
curve(IFhuber(x,c=c0.85),add=T,lty=3)
abline(h=0,v=0)
segments(0,sqrt(pi/2),4,sqrt(pi/2),lty=4)
segments(0,-sqrt(pi/2),-4,-sqrt(pi/2),lty=4)
legend('topleft',c('Huber 97.5%', 'Huber 95%','Huber 85%','Median'))


##right panel
eps<-seq(0,0.499,l=50)
ord<-sapply(eps, fun.mb, k=c0.975)
plot(eps,abs(ord),type='l',xlab=expression(epsilon),ylab='MB',lty=1)
ord2<-sapply(eps, fun.mb, k=c0.95)
lines(eps,abs(ord2),lty=2)
ord3<-sapply(eps, fun.mb, k=c0.85)
lines(eps,abs(ord3),lty=3)
curve(qnorm(0.5/(1-x)),add=T,lty=4)
legend('topleft',c('Huber 97.5%', 'Huber 95%','Huber 85%', 'Median'), lty=1:4)



## Figure 2.3
curve(x*psi.huber(x,k=1.345), from=-6,to=6, ylab=expression(psi(x)))
curve(Mpsi(x,psi='bisquare',cc=4.685),add=T,lty=2)
legend('topleft', c('Huber','Tukey'),lty=1:2)
curve(psi.huber(x,k=1.345), from=-6,to=6, ylab=expression(w(x)),ylim=c(0,1))
curve(Mwgt(x,psi='bisquare',cc=4.685),add=T,lty=2)
legend('topleft', c('Huber','Tukey'),lty=1:2)

## Figure 2.5
curve(IFqn(x),from=-5,to=5,ylim=c(-2,4),xlab='x',ylab='IF')
curve(IFmad,add=T,lty=2)
curve(IFS(x,c=1.547661,alpha=0.5),add=T,lty=3)
abline(v=0,h=0)
legend('topleft', c(expression(Q[n]),'MAD','S'),lty=1:3)


