## Influence Function for Huber estimator of location

IFhuber<-function(x,c)
{
	den<-2*pnorm(c)-1
	x*psi.huber(x,k=c)/den
}

## Max Bias Curve for Huber estimator of location

gfun<-function(t,k)
{
	fun.int<-function(x) (x-t)*psi.huber(x-t,k)*dnorm(x)
	integrate(fun.int, lower=-Inf,upper=Inf)$value
}

fun.mb<-function(e,k,l=-4,u=0)
{
fun.int<-function(t,k,e) -gfun(t,k)+k*e/(1-e)
uniroot(fun.int, e=e, k=k,lower=l,upper=u)$root
}


### (2.5)
areH<-function(c)
{
	num<-2*pnorm(c)-1
	num<-num^2
	den<-2*c^2*(1-pnorm(c))+2*pnorm(c)-1-2*c*dnorm(c)
	num/den
}

## Find c for fixed efficiency
link.eff.c<-function(eff,c) 
{
	out<-areH(c=c)
	eff-out
}


find.c<-function(eff,l=.01,u=15)
{
	out<-uniroot(link.eff.c, eff=eff,lower=l,upper=u)
	out$root
}


hfun<-function(t,c)
{ 
out<-pchisq(c^2, t+1)
if(t<=2) {
const<-1
} else {
t<-t-1
pp<-sapply(1: (round(t/2)-1), function(x) t-2*x)
const<-t*prod(pp)}
const*out
}



### (2.7)
areT<-function(c)
{
	num<-2*pnorm(c)-1-6*hfun(2,c)/(c^2)+5*hfun(4,c)/(c^4)
	num<-num^2
	den<-hfun(2,c)-4*hfun(4,c)/(c^2)+6*hfun(6,c)/(c^4)-4*hfun(8,c)/(c^6)+hfun(10,c)/(c^8)
	num/den
}

## Find c for fixed efficiency
T.link.eff.c<-function(eff,c) 
{
	out<-areT(c=c)
	eff-out
}


T.find.c<-function(eff,l=.01,u=15)
{
	out<-uniroot(T.link.eff.c, eff=eff,lower=l,upper=u)
	out$root
}



### (2.14)
BPT<-function(alpha,c)
{
	hfun(2,c)/2-hfun(4,c)/(2*c^2)+hfun(6,c)/(6*c^4)+c^2*(1-pnorm(c))/3-alpha*c^2/6
}

IFQn<-function(x)
{
d=2.219
den=integrate(function(y) dnorm(y+1/d)*dnorm(y),lower=-Inf,upper=Inf)$value
d*(0.25-pnorm(x+1/d)+pnorm(x-1/d))/den
}

Ifmad<-function(x) 
{
	dmad<-4*qnorm(3/4)*dnorm(qnorm(3/4))
	sign(abs(x)-qnorm(3/4))/dmad
}

IFS<-function(x,c,alpha)
{
	num<-Mchi(x,psi='bisquare',cc=c)-c^2/6*alpha
	den<-pchisq(c^2,3)-6*pchisq(c^2,5)/(c^2)+15*pchisq(c^2,6)/(c^4)
	num/den
}

