library(rrcov);library(EBImage)
video<-read.table('video.dat')
#colnames(video)<-1:506
### first 100 frames
video<-video[,1:100]
### transpose
video2<-t(video)

### classic PCA via SVD

video.mean<-colMeans(video2)
video.center<-sapply(1:ncol(video2), function(j) video2[,j]-video.mean[j])
video.pc<-svd(video.center)

### PCA reconstruction 
Z.pc<-video.pc$u%*%diag(video.pc$d)
k=5
Z.pc.k<-Z.pc[,1:k]
V.pc.k<-video.pc$v[,1:k]
video.pc.rec<-t(t(Z.pc.k%*%t(V.pc.k)) + video.mean)


### ROBPCA

video.rpc<-PcaHubert(video2, alpha=0.5,k=5)
### ROBPCA reconstruction  
k=5
Z.rpc.k<-video.rpc@scores[,1:k]
V.rpc.k<-video.rpc@loadings[,1:k]
video.rpc.rec<-t(t(Z.rpc.k%*%t(V.rpc.k)) + video.rpc@center)


## PP
out.pp<-PCAgrid(video2, k=5,method='mad')

### PP reconstruction  
k=5
Z.rpc.k.pp<-out.pp$scores[,1:k]
V.rpc.k.pp<-out.pp$loadings[,1:k]
video.rpc.rec.pp<-t(t(Z.rpc.k.pp%*%t(V.rpc.k.pp)) + out.pp$center)

## Function to rotate the frame
rot <- function(m) t(m)[,nrow(m):1]

### To represent the frame number 'pic' in Figure 3.15 
image(rot(matrix(video.rpc[,pic],120,160)),col=gray((1:1000)/1000))
