### Spam data: illustrative example

spam20<-read.table('.../spam20.dat')

### Standard PCA
pca.spam<-princomp(spam20)
summary(pca.spam)
screeplot(pca.spam,npcs=10,type='lines',main='')

### Sparse PCA
library(elasticnet)

sparsity<-20:1
pev<-s1<-NULL
### pev == percentage of expalined adjusted variance in sPCA 
for(i in 1:20)
{
	out<-spca(cov(spam20), K=1,type='Gram', 
	para=sparsity[i],sparse='varnum')
	pev[i]<-out$pev
}

plot(sparsity, pev, type='b', xlab='Number of non null loadings', ylab='Explained Variance')