library(ade4);library(psych)
data(butterfly)

X<-butterfly$envir
Y<-butterfly$genet
Y<-cbind(Y[,1]+Y[,2], Y[,3:5])
colnames(Y)<-c('0.4-0.6','0.8','1','1.16')
XY<-cbind(X,Y)


S.mm<-CovMMest(XY)
mm.cor<-cov2cor(S.mm@cov)

## scree-plot 
R.mm<-cov2cor(S.mm@cov)
eig.mm<-eigen(R.mm)
plot(eig.mm$values, type='b',xlab='Number of factors',ylab='Eigenvalues')
abline(h=1,lty=2)

## Classical FA
af.butt.clas<-fa(r=cor(XY), nfactors=2,rotate='varimax',covar=FALSE,scores='regression',fm='ml')
scores.butt.clas<-t(t(af.butt.clas$loadings)%*%solve(cor(XY))%*%t(scale(XY)))
biplot(scores.butt.clas,af.butt.clas$loadings,main='Classical',xlab='Factor 1', ylab='Factor 2',
col=c('black','gray'))
### Robust FA
af.butt<-fa(r=R.mm, nfactors=2,rotate='varimax',covar=FALSE,scores='regression',fm='ml')
XYc<-sapply(1:ncol(XY), function(j) (XY[,j]-S.mm@center[j])/sqrt(S.mm@cov[j,j]))
row.names(XYc)<-rownames(XY)
scores.butt<-t(t(af.butt$loadings)%*%solve(R.mm)%*%t(XYc))
biplot(scores.butt,af.butt$loadings,main='MM estimation',xlab='Factor 1', ylab='Factor 2',
col=c('black','gray'))


