## K-MEANS ###

## g7 example ## 

g7=read.table("g7.txt",header=T)

data.frame(g7[,1],kmeans(scale(g7[,-1]),3,nstart=10,iter.max=100)$clust)

## metallic oxide example ## 

source("rand.index.r")

fell=read.table("fellner.csv",header=T,sep=",")

cl2=kmeans(fell[,-1],2)$cl
cl3=kmeans(fell[,-1],3)$cl

rand.index(unclass(fell[,1]),cl2)

table(cl3)

# rand index after discarding the two outliers 
rand.index(unclass(fell[-which(cl3==3),1]),cl3[cl3!=3])

### water treatment ## 

water=read.table("water-treatment.data",header=FALSE,sep=",",na.strings="?")
water=water[complete.cases(water),]

km=kmeans(water[,2:30],3,nstart=10,iter.max=100)

std=scale(water[,-1])

tapply(apply(std[,1:9],1,mean),km$cl,mean)

tapply(apply(std[,10:15],1,mean),km$cl,mean)

tapply(apply(std[,16:22],1,mean),km$cl,mean)

tapply(apply(std[,23:29],1,mean),km$cl,mean)

### Model Based Clustering ###

library(mclust)

mg7=Mclust(scale(g7[,-1]),3)

mg7
mg7$class

cl2=Mclust(fell[,-1],2)
cl3=Mclust(fell[,-1],3)

rand.index(unclass(fell[,1]),cl2$class)

table(cl3$class)

# rand index after discarding the two outliers 
rand.index(unclass(fell[-which(cl3$class==3),1]),cl3$class[cl3$class!=3])

wmclust=Mclust(water[,2:30],3)

table(wmclust$class)

tapply(apply(std[,1:9],1,mean),wmclust$cl,mean)

tapply(apply(std[,10:15],1,mean),wmclust$cl,mean)

tapply(apply(std[,16:22],1,mean),wmclust$cl,mean)

tapply(apply(std[,23:29],1,mean),wmclust$cl,mean)


#### choosing the number of clusters ###

library(fpc) 

km4=kmeans(fell[,-1],4)
km4$centers
apply(fell[,-1],2,function(x) tapply(x,km4$cl,sd))


km3=kmeans(fell[,-1],3)
km3$centers
apply(fell[,-1],2,function(x) tapply(x,km3$cl,sd))

km2=kmeans(fell[,-1],2)
km2$centers
apply(fell[,-1],2,function(x) tapply(x,km2$cl,sd))

apply(fell[,-1],2,mean)
apply(fell[,-1],2,sd)

#

sil=rep(NA,9)
for(k in 2:9) {
sil[k]=cluster.stats(dist(fell[,-1]),kmeans(fell[,-1],centers=k)$cl)$avg.silwidth
}

which.max(sil)

gap=clusGap(fell[,-1],kmeans,K.max=9,nstart=10,iter.max=100,B=1000)
print(gap,method="Tibs2001")

cbind(sil,gap$Tab[,3:4],Mclust(fell[,-1])$BIC)




Mclust(water[,2:30])


